﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Web;
using Wisej.Core;

namespace CKEditorPlainText
{
    public class MyCKEditor : Wisej.Web.Ext.CKEditor.CKEditor
    {
        private Dictionary<int, Action<string>> callbacks;

        [WebMethod]
        public void __GetPlainTextCallback(string text, int callbackId)
        {
            // TODO: Change to TryGetValue
            Action<string> callback = this.callbacks[callbackId];
            this.callbacks.Remove(callbackId);
            callback(text);
        }

        public void GetPlainText(Action<string> callback)
        {
            if (callback == null)
                throw new ArgumentNullException("callback");

            this.callbacks = this.callbacks ?? new Dictionary<int, Action<string>>();
            this.callbacks[callback.GetHashCode()] = callback;
            Eval("this.__GetPlainTextCallback(this.editor.document.getBody().getText(), " + callback.GetHashCode() + ")");
        }

		protected override void OnWebRender(dynamic config)
		{
			base.OnWebRender((object)config);

			config.webMethods = new[] { "__GetPlainTextCallback" };
		}

	}
}